require 'mscorlib'
require 'System.Windows.Forms'
require 'System.Drawing'

require 'display_gerber.rb'

class GgcMainWindow
  def initialize
    @glscreen = nil
    # - item
    @form = System::Windows::Forms::Form.new()
    @toolStripMenuItem2 = System::Windows::Forms::ToolStripSeparator.new()
    @exportGCodeToolStripMenuItem = System::Windows::Forms::ToolStripMenuItem.new()
    @exportOneCutterGCodeToolStripMenuItem = System::Windows::Forms::ToolStripMenuItem.new()
    @toolStripMenuItem1 = System::Windows::Forms::ToolStripSeparator.new()
    @openDrillToolStripMenuItem = System::Windows::Forms::ToolStripMenuItem.new()
    @openOutlineToolStripMenuItem = System::Windows::Forms::ToolStripMenuItem.new()
    @openPatternGerberToolStripMenuItem = System::Windows::Forms::ToolStripMenuItem.new()
    @fileToolStripMenuItem = System::Windows::Forms::ToolStripMenuItem.new()
    @menuStrip1 = System::Windows::Forms::MenuStrip.new
    @buildPatternPathToolStripMenuItem = System::Windows::Forms::ToolStripMenuItem.new()
    @buildToolStripMenuItem = System::Windows::Forms::ToolStripMenuItem.new()
    @propertyToolStripMenuItem = System::Windows::Forms::ToolStripMenuItem.new()
    @clearToolStripMenuItem = System::Windows::Forms::ToolStripMenuItem.new()
    @hmirrorToolStripMenuItem = System::Windows::Forms::ToolStripMenuItem.new()
    @editToolStripMenuItem = System::Windows::Forms::ToolStripMenuItem.new()
    @exitToolStripMenuItem = System::Windows::Forms::ToolStripMenuItem.new()
    #
    form_build
  end


  attr_accessor :glscreen


  def form_build
    # --- menu
    # - property
    @menuStrip1.Items.AddRange(System::Array[System::Windows::Forms::ToolStripItem].new([@fileToolStripMenuItem,
                                                                                        @editToolStripMenuItem,
                                                                                        @buildToolStripMenuItem]))
    @menuStrip1.Location = System::Drawing::Point.new(0, 0)
    @menuStrip1.Name = 'menuStrip1'
    @menuStrip1.Size = System::Drawing::Size.new(657, 26)
    @menuStrip1.TabIndex = 0
    @menuStrip1.Text = 'menuStrip1'
    #
    @fileToolStripMenuItem.DropDownItems.AddRange(System::Array[System::Windows::Forms::ToolStripItem].new([@openPatternGerberToolStripMenuItem,
                                                                                                           @openOutlineToolStripMenuItem,
                                                                                                           @openDrillToolStripMenuItem,
                                                                                                           @toolStripMenuItem1,
                                                                                                           @exportGCodeToolStripMenuItem,
                                                                                                           @exportOneCutterGCodeToolStripMenuItem,
                                                                                                           @toolStripMenuItem2,
                                                                                                           @exitToolStripMenuItem]))
    @fileToolStripMenuItem.Name = 'fileToolStripMenuItem'
    @fileToolStripMenuItem.Size = System::Drawing::Size.new(40, 22);
    @fileToolStripMenuItem.Text = 'File'
    #
    @openPatternGerberToolStripMenuItem.Name = 'openPatternGerberToolStripMenuItem'
    @openPatternGerberToolStripMenuItem.Size = System::Drawing::Size.new(197, 22)
    @openPatternGerberToolStripMenuItem.Text = 'Open Pattern Gerber'
    @openPatternGerberToolStripMenuItem.Click{ |sender, e| menu_open_pattern }
    #
    @openOutlineToolStripMenuItem.Name = 'openOutlineToolStripMenuItem'
    @openOutlineToolStripMenuItem.Size = System::Drawing::Size.new(197, 22)
    @openOutlineToolStripMenuItem.Text = 'Open Outline'
    @openOutlineToolStripMenuItem.Click{ |sender, e| menu_open_outline }
    #
    @openDrillToolStripMenuItem.Name = 'openDrillToolStripMenuItem'
    @openDrillToolStripMenuItem.Size = System::Drawing::Size.new(197, 22)
    @openDrillToolStripMenuItem.Text = 'Open Drill'
    @openDrillToolStripMenuItem.Click{ |sender, e| menu_open_drill }
    #
    @toolStripMenuItem1.Name = 'toolStripMenuItem1'
    @toolStripMenuItem1.Size = System::Drawing::Size.new(194, 6)
    #
    @exportGCodeToolStripMenuItem.Name = 'exportGCodeToolStripMenuItem'
    @exportGCodeToolStripMenuItem.Size = System::Drawing::Size.new(197, 22)
    @exportGCodeToolStripMenuItem.Text = 'Export G-Code'
    @exportGCodeToolStripMenuItem.Click{ |sender, e| menu_export }
    #
    @exportOneCutterGCodeToolStripMenuItem.Name = 'exportOneCutterGCodeToolStripMenuItem'
    @exportOneCutterGCodeToolStripMenuItem.Size = System::Drawing::Size.new(197, 22)
    @exportOneCutterGCodeToolStripMenuItem.Text = 'Export One Cutter Op. G-Code'
    @exportOneCutterGCodeToolStripMenuItem.Click{ |sender, e| menu_export_onecutter }
    #
    @toolStripMenuItem2.Name = 'toolStripMenuItem2'
    @toolStripMenuItem2.Size = System::Drawing::Size.new(194, 6)
    #
    @exitToolStripMenuItem.Name = 'exitToolStripMenuItem'
    @exitToolStripMenuItem.Size = System::Drawing::Size.new(197, 22)
    @exitToolStripMenuItem.Text = 'Exit'
    @exitToolStripMenuItem.Click{ |sender, e| menu_exit }
    #
    @editToolStripMenuItem.DropDownItems.AddRange(System::Array[System::Windows::Forms::ToolStripItem].new([@clearToolStripMenuItem,@propertyToolStripMenuItem,@hmirrorToolStripMenuItem]))
    @editToolStripMenuItem.Name = 'editToolStripMenuItem'
    @editToolStripMenuItem.Size = System::Drawing::Size.new(42, 22)
    @editToolStripMenuItem.Text = 'Edit'
    #
    @clearToolStripMenuItem.Name = 'clearToolStripMenuItem'
    @clearToolStripMenuItem.Size = System::Drawing::Size.new(152, 22)
    @clearToolStripMenuItem.Text = 'Clean'
    @clearToolStripMenuItem.Click{ |sender, e| menu_clean }
    #
    @propertyToolStripMenuItem.Name = 'propertyToolStripMenuItem'
    @propertyToolStripMenuItem.Size = System::Drawing::Size.new(152, 22)
    @propertyToolStripMenuItem.Text = 'Preference'
    @propertyToolStripMenuItem.Click{ |sender, e| menu_preference }
    #
    @hmirrorToolStripMenuItem.Name = 'hmirrorToolStripMenuItem'
    @hmirrorToolStripMenuItem.Size = System::Drawing::Size.new(152, 22)
    @hmirrorToolStripMenuItem.Text = 'Horizontal Mirror'
    @hmirrorToolStripMenuItem.Click{ |sender, e| menu_h_mirror }
    #
    @buildToolStripMenuItem.DropDownItems.AddRange(System::Array[System::Windows::Forms::ToolStripItem].new([@buildPatternPathToolStripMenuItem]))
    @buildToolStripMenuItem.Name = 'buildToolStripMenuItem'
    @buildToolStripMenuItem.Size = System::Drawing::Size.new(48, 22)
    @buildToolStripMenuItem.Text = 'Build'
    #
    @buildPatternPathToolStripMenuItem.Name = 'buildPatternPathToolStripMenuItem'
    @buildPatternPathToolStripMenuItem.Size = System::Drawing::Size.new(181, 22)
    @buildPatternPathToolStripMenuItem.Text = 'Build pattern path'
    @buildPatternPathToolStripMenuItem.Click{ |sender, e| menu_build }

    # --- screen panel
    @panel_screen = System::Windows::Forms::Panel.new()
    @panel_screen.AutoSize = true
    #panel_screen.Dock = System::Windows::Forms::DockStyle.Fill
    @panel_screen.Name = 'panel_screen'
    @panel_screen.Location = System::Drawing::Point.new(0, 26)
    @panel_screen.Size = System::Drawing::Size.new(657, 425)

    @glscreen = MYGLPanelViewGerber.new(@panel_screen)

    @menuStrip1.Resize{
      client = @form.ClientRectangle
      rec = @menuStrip1.ClientRectangle
      @panel_screen.Location = System::Drawing::Point.new(0, rec.Bottom)
      @panel_screen.Size = System::Drawing::Size.new(client.Width, client.Height - rec.Bottom)
      @panel_screen.Paint
    }

    # --- this form
    @form.ClientSize = System::Drawing::Size.new(657, 451)
    @form.ShowIcon = false
    @form.Text = 'Gynostemma-PCB / Gerver to G-Code Converter'
    @form.ResumeLayout(false)
    @form.Controls.Add(@menuStrip1)
    @form.Controls.Add(@panel_screen)
    @form.FormClosed{ on_close }

  end

  # -----------------------------
  # --- menu event
  # -----------------------------

  # --- exit apprication
  def menu_exit
    @form.Close
  end

  # --- load pattern gerber data
  def menu_open_pattern
  end

  # --- load cutting outline
  def menu_open_outline
  end

  # --- load drill data
  def menu_open_drill
  end

  # --- export G-Code
  def menu_export
  end

  def menu_export_onecutter
  end

  # --- set preference
  def menu_preference
  end

  # --- build carve path
  def menu_build
  end

  # --- eraser
  def menu_clean
  end

  # --- mirror
  def menu_h_mirror
  end

  # --- exit action
  def on_close
  end

  # -----------------------------
  # --- execute
  # -----------------------------

  def show_dialog
    # --- show window
    @form.ShowDialog()
  end

  def run
    System::Windows::Forms::Application.run(@form)
  end

end
